from pyfiglet import Figlet
from os import system
from colored import Fore, Style #Documentation: https://dslackw.gitlab.io/colored/user_guide/user_guide/#user-guide
from time import sleep
import os

"""
These are global variables, some can be changed.
"""

"""
GLOBALS
"""
global scoreDefault # Default score, this is the max score you can achieve without extra credit
global score
global name
global late
global latePenalty
global pointsForRun
global title
global defaults

"""
 * CHANGEABLE
"""
# Student Variables

scoreDefault = 100 # What the score is out of

# Title of lab rubric

title = "Name of Assignment"

# Default points stored for each run. Each list entry is a run. A default run score of 0 allows extra credit.

defaults = [10,15,20,0]

# Late penalty if submission is late. 0 for no penalty

latePenalty = scoreDefault * 0.1 # 10% of score default

"""
! NON CHANGEABLE
"""

# DO NOT MODIFY SCORE

score = scoreDefault # actual score, copies score default to first start off

# DO NOT MODIFY NAME

name = "" # Name of student

# DO NOT MODIFY LATE

late = False # was the assignment turned in late? Default is false.



pointsForRun = []

"""
End of Variable Statements
"""


def clear():
 
    # for windows, os.name is 'nt'
    if os.name == "nt":
        os.system('cls')
 
    # for mac and linux(here, os.name is 'posix')
    else:
        os.system('clear')



def operation():
    choice = input("[1] Change run score | [2] Change Name | [3] Change Tardy | [4] Restart Script | [5] Exit : ")
    # Adjust Score
    if choice == "1":
        adjustScore()
        return True
    # Change name
    elif choice == "2":
        global name
        nameChange = input("New name: ")
        name = nameChange
        return True
    # Change late penalty
    elif choice == "3":
        adjustLate()
        return True
    # Restart program
    elif choice == "4":
        return False
    # Exit Program
    elif choice == "5":
        exit()
    else:
        print("Please choose a valid result...")
        sleep(2)
        return True
    pass

# Scoring operations
# def incorrectStyling(count):
#     global incorrectStyles
#     global score
#     inverseStyles = incorrectStyles * -1
#     incorrectStyles = count
#     score = score - (inverseStyles * 3)
#     score = score - (incorrectStyles * 3)

# def htmlModified(count):
#     global modifiedHTMLs
#     global score
#     inverseHTML = modifiedHTMLs * -1
#     modifiedHTMLs = count
#     score = score - (inverseHTML * 5)
#     score = score - (modifiedHTMLs * 5)

def validateInput(answer):
    if answer == "n" or answer == "N":
        return False
    else:
        return True

def addToScore(boolean, number):
    global score
    if boolean is True:
        score = score + int(number)

def subtractFromScore(boolean, number):
    global score
    if boolean is True:
        score = score - int(number)

def adjustLate():
    global late
    global score
    global latePenalty
    onTime = validateInput(input("Did the student turn in the assignment within 48 hours? [Y/n]: "))
    if onTime:
        points = latePenalty
    else:
        points = -latePenalty
    if onTime == late:
        score = score + points
        late = not onTime

def boolResult(boolean):
    if boolean:
        return f'{Fore.green}Yes{Style.reset}'
    else:
        return f'{Fore.red}No{Style.reset}'



def assignScore(default, points):
    global score
    global pointsForRun
    pointsForRun.append(points)
    invertPoints = default - points
    score = score - invertPoints


def runScore():
    run = 1
    while(run <= len(defaults)):
        # Insert default point conditions here
        default = defaults[run - 1]
        
        points = input("Run " + str(run) + ": How many points should be assigned? [Default " + str(default) + "]: ")
        if points == "":
            points = default
        else:
            points = int(points)
        assignScore(default, points)
        run = run + 1


def printRuns():
    global pointsForRun
    count = 1
    for point in pointsForRun:
        print("Run " + str(count) + ": " + f'{Fore.yellow}' + str(point) + f'{Style.reset}')
        count = count + 1

def adjustScore():
    global score
    global pointsForRun
    global defaults
    run = input("Adjust score for which run?: ")
    if run == "":
        print("Please enter an actual number")
        sleep(1)
        return
    else:
        run = int(run)
    if run < 1 or run > len(defaults):
        print("Run out of range")
        sleep(1)
        return
    index = run - 1
    print()
    print("Run " + str(run) + ": " + f'{Fore.yellow}' + str(pointsForRun[index]) + f'{Style.reset}')

    # Insert default point conditions here
    
    default = defaults[index]
    
    print("Default: " + str(default))
    print()
    newScore = input("Score should be changed to: ")
    if newScore == "":
        newScore = default
    else:
        newScore = int(newScore)
    oldScore = pointsForRun[index]
    score = score - (oldScore - newScore)
    pointsForRun[index] = newScore

# Main function
def main():
    global score
    global name
    global late
    global latePenalty
    global pointsForRun
    global title
    while True:

        clear()
        titleText = Figlet(font='standard')
        print(titleText.renderText(title))
        print()
        name = input("Student name?: ")
        late = not validateInput(input("Did the student turn in the assignment within 48 hours? [Y/n]: "))
        if(late):
            score = score - latePenalty

        scoreLoop = True;
        scoring = True;
        while scoreLoop:
            # Clear console and print title and score
            clear()
            print(titleText.renderText(title))
            print("Student name: " + f'{Fore.blue}' + name + f'{Style.reset}')
            print()
            if scoring:
                runScore()
                scoring = False
            else:
                # scoreText = Figlet(font='slant')
                # print(scoreText.renderText("Score = " + str(score)))
                print("Score = " + f'{Fore.rgb(254,110,222)}' + str(score) + f'{Style.reset}')
                # 
                # print("Modified HTMLs: " + f'{Fore.yellow}' + str(modifiedHTMLs) + f'{Style.reset}')
                print("Turned in on time?: " + boolResult(not late))
                print()
                printRuns()
                print()
                print("Choose:")
                scoreLoop = operation()
        
        
        score = scoreDefault
        name = ""
        pointsForRun = []
        late = False


main()
